'	****************************************************************
'	*  This module contains an example high level layer for the    *
'	*  Microsoft QuickBASIC Compiler Version 4.0.  Older versions  *
'	*  of the compiler will require modification.  We suggest you  *
'	*  update your compiler if needed.			       *
'	*							       *
'	*  Last Revised: 1/31/88				       *
'	*  Written By:  Ed Connell				       *
'	*		Connell Scientific Graphics		       *
'	*		Woodinville WA, 98072			       *
'	****************************************************************
rem	$static
	defint a-z
	dim pt(101),func(2)
	common shared pt(),func(),badd(),tx$


	SUB INIT( mode ) STATIC
'	This routine is used to set the graphics mode
'	----------------------------------------------------------------
'------
	pt(0)=mode
	pt(1)=0
	calls EGAC16( 0 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB FINIT STATIC
'	This routine is used to terminate graphics mode
'	----------------------------------------------------------------
'------
	calls EGAC16( 0,0 )
	end sub
'
'	****************************************************************
'
	SUB DERASE STATIC
'	This routine is used to erase the display
'	----------------------------------------------------------------
'------
	calls EGAC16( 1,0 )
	end sub
'
'	****************************************************************
'
	SUB COLMAP( ind , ir , ig , ib ) STATIC
'	This routine is used to set a colormap register.
'	----------------------------------------------------------------
'------
	pt(0)=ind : pt(1)=ir : pt(2)=ig : pt(3)=ib 
	calls EGAC16( 2,pt(0) )
	end sub
'
'	****************************************************************
'
	SUB INQMAP( ind , ir , ig , ib ) STATIC
'	This routine is used to inquire on a colormap register.
'	----------------------------------------------------------------
'------
	pt(0)=ind
	calls EGAC16( 3,pt(0) )
	ir=pt(1) : ig=pt(2) : ib=pt(3)
	end sub
'
'	****************************************************************
'
	SUB DRWLOG( ltype ) STATIC
'	This routine is used to set the drawing logic.
'	----------------------------------------------------------------
'------
	calls EGAC16( 4,ltype )
	end sub
'
'	****************************************************************
'
	SUB DCOLOR( icol ) STATIC
'	This routine is used to set the drawing color.
'	----------------------------------------------------------------
'------
	calls EGAC16( 5,icol )
	end sub
'
'	****************************************************************
'
	SUB MOVEAB( ix , iy ) STATIC
'	This routine is used to move the current ptsition absolutely.
'	----------------------------------------------------------------
'------
	pt(0)=ix : pt(1)=iy	
	calls EGAC16( 6,pt(0) )
	end sub
'
'	****************************************************************
'
	SUB DRAWAB( ix , iy ) STATIC
'	This routine is used to draw a line from the current
'	ptsition to the specified absolute coordinate.
'	----------------------------------------------------------------
'------
	pt(0)=ix : pt(1)=iy
	calls EGAC16( 7,pt(0) )
	end sub
'
'	****************************************************************
'
	SUB POLYAB( nv , pnts(1) , fill ) STATIC
'	This routine is used to draw a line through the supplied
'	list of absolute vertices.  If filled is true, the bounded
'	region will be filled not outlined.
'	The limit is set to 100 points in this module.  There is no
'	point limit in the driver.  If you want to draw more than 100
'	at a time, increase the size of PT and adjust this routine.
'	----------------------------------------------------------------
'------ Transfer points from dynamic to static array
	np=nv*2
	if( np <= 100 ) then _
		for n=0 to np-1 : pt(n)=pnts(n) : next n _
	else _
		print "POLYAB Too many points" : return
'------
	func(1)=nv
	if ( fill ) then _
		func(0)=9 : _
		calls EGAC16( func(0),pt(0) ) _
	else _
		func(0)=8 : _
		calls EGAC16( func(0),pt(0) )


	end sub
'
'	****************************************************************
'
	SUB RECTAB( ix1 , iy1 , ix2 , iy2 , fill ) STATIC
'	This routine is used to draw a rectangle.  If fill is true,
'	the region will be filled.
'	----------------------------------------------------------------
'------
	pt(0)=ix1 : pt(1)=iy1 : pt(2)=ix2 : pt(3)=iy2
	if( fill ) then _
		calls EGAC16( 11,pt(0) ) _
	else _
		calls EGAC16( 10,pt(0) )
	end sub
'
'	****************************************************************
'
	SUB FLOOD( ix , iy ) STATIC
'	This routine is used to flood a bounded region.
'	----------------------------------------------------------------
'------
	pt(0)=ix : pt(1)=iy
	calls EGAC16( 12,pt(0) )
	end sub
'
'	****************************************************************
'
	SUB RLENFL( icol, icnt, direc ) STATIC
'	This routine is used to perform a run length fill
'	----------------------------------------------------------------
'------
	pt(0)=icol : pt(1)=icnt	: pt(2)=direc
	calls EGAC16( 13 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB LNSTYL( istyle ) STATIC
'	This routine is used to set the line style.
'	----------------------------------------------------------------
'------
	pt(0)=istyle
	calls EGAC16( 14 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB FLSTYL( fstyle(1) ) STATIC
'	This routine is used to set the fill style.
'	It packs the data into a byte array
'	----------------------------------------------------------------
'------
	for j=0 to 31
		pt(j)=( fstyle(j*2)*256 )+fstyle( (j*2)+1 )
	next j
	calls EGAC16( 15,pt(0) )
	end sub
'
'	****************************************************************
'
	SUB PATBCL( ibcol ) STATIC
'	This routine is used to set the pattern overlay logic.
'	----------------------------------------------------------------
'------
	pt(0)=ibcol
	calls EGAC16( 16,pt(0) )
	end sub
'
'	****************************************************************
'
	SUB TEXT( tx$ ) STATIC
'	This routine is used to draw text on the display
'	Please excuse the method of how we packed characters into
'	an integer array.  If you know a faster method please give us
'	a call.      C.S.G.
'	----------------------------------------------------------------
	func(0)=17
	func(1)=len(tx$)
	temp$=tx$+"null"
	inc=1
	for n=0 to (func(1)/2)
		pt(n)=asc(mid$(temp$,inc+1,1))
		pt(n)=(256*pt(n))+asc(mid$(temp$,inc,1))
		inc=inc+2
	next n
	calls EGAC16( func(0), pt(0) )
	end sub
'
'	****************************************************************
'
	SUB DFNFNT( iadd(1) , ih , hp ) STATIC
'	This routine is used to define a raster font.
'	----------------------------------------------------------------
'------
	pt(0)=iadd(0) : pt(1)=iadd(1) : pt(2)=ih : pt(3)=hp
	calls EGAC16( 18 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB RDPBLK( wid , high , buff(1) ) STATIC
'	This routine is used to read a pixel block.
'	----------------------------------------------------------------
'------
	pt(0)=wid : pt(1)=high
	pt(2)=VARPTR( buff(0) )
	pt(3)=VARSEG( buff(0) )
	calls EGAC16( 19 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB WRPBLK( wid , high , buff(1) ) STATIC
'	This routine is used to write a pixel block
'	----------------------------------------------------------------
'------
	pt(0)=wid : pt(1)=high
	pt(2)=VARPTR( buff(0) )
	pt(3)=VARSEG( buff(0) )	
	calls EGAC16( 20,pt(0) )
	end sub
'
'	****************************************************************
'
	SUB RDBBLK( wid , high , buff(1) ) STATIC
'	This routine is used to read a bit block.
'	----------------------------------------------------------------
'------
	pt(0)=wid : pt(1)=high
	pt(2)=VARPTR( buff(0) )
	pt(3)=VARSEG( buff(0) )	
	calls EGAC16( 21 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB WRBBLK( wid , high , buff(1) ) STATIC
'	This routine is used to write a bit block
'	----------------------------------------------------------------
'------
	pt(0)=wid : pt(1)=high
	pt(2)=VARPTR( buff(0) )
	pt(3)=VARSEG( buff(0) )	
	calls EGAC16( 22 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB CPYBLK( sx,sy,dx,dy,iw,ih ) STATIC
'	This routine is used to copy a pixel block
'	----------------------------------------------------------------
'------
	pt(0)=sx : pt(1)=sy : pt(2)=dx : pt(3)=dy
	pt(4)=iw : pt(5)=ih
	calls EGAC16( 23 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB RDMASK( mask ) STATIC
'	This routine is used to set the bit plane read mask.
'	----------------------------------------------------------------
'------
	calls EGAC16( 24 , mask )
	end sub
'
'	****************************************************************
'
	SUB WRMASK( mask ) STATIC
'	This routine is used to set the bit plane write mask.
'	----------------------------------------------------------------
'------
	calls EGAC16( 25 , mask )
	end sub
'
'	****************************************************************
'
	SUB RWPAGE( iread , iwrite ) STATIC
'	This routine is used to set the read and write
'	enabled pages.
'	----------------------------------------------------------------
'------
	pt(0)=iread : pt(1)=iwrite
	calls EGAC16( 26 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB VPAGE( ipage ) STATIC
'	This routine is used to set the visual page.
'	----------------------------------------------------------------
'------
	calls EGAC16( 27 , ipage )
	end sub
'
'	****************************************************************
'
	SUB PAN( ulx , uly ) STATIC
'	This routine is used to pan the display.
'	----------------------------------------------------------------
'------
	pt(0)=ulx : pt(1)=uly
	calls EGAC16( 28 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB VWAIT( icnt ) STATIC
'	This routine is used to wait the specified number of
'	vertical retraces.
'	----------------------------------------------------------------
'------
	for j=1 to icnt : calls EGAC16( 29 , 0 ) : next j
	end sub
'
'	****************************************************************
'
	SUB INQMEM( imem ) STATIC
'	This routine is used to determine the amount of graphics
'	memory installed on the EGA.
'	----------------------------------------------------------------
'------
	calls EGAC16( 30 , imem )
	end sub
'
'	****************************************************************
'
	SUB SPLIT( sline ) STATIC
'	This routine is used to create a split screen display.
'	----------------------------------------------------------------
'------
	calls EGAC16( 31 , sline )
	end sub
'
'	****************************************************************
'
	SUB SWIDTH( iwid ) STATIC
'	This routine is used to set the logical screen width in words.
'	----------------------------------------------------------------
'------
	calls EGAC16( 32 , iwid )
	end sub
'
'	****************************************************************
'
	SUB FONADD( hi , inst , fadd(1) ) STATIC
'	This routine is used to find a raster font in the EGA.
'	It is used for compatability with clone boards.
'	HI   := is cell height
'	INST := 1 installs vector if data is found
'		0 doesn't
'	FADD := (0) = offset, (1) = segment
'	----------------------------------------------------------------
'------
	pt(0)=hi : pt(1)=inst
	calls EGAC16( 33 , pt(0) )
	if( pt(0) = 1 ) then _
		fadd(0)=pt(1) : fadd(1)=pt(2) _
	else _
		fadd(0)=0 : fadd(1)=0
	end sub
'
'	****************************************************************
'
	SUB SAVREG( iwid , ihigh , offset , SorR ) STATIC
'	This routine is used to save a region of the display.
'	----------------------------------------------------------------
'------
	pt(0)=iwid : pt(1)=ihigh : pt(2)=offset : pt(3)=SorR
	calls EGAC16( 34 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB LITPEN( ix , iy ) STATIC
'	This routine is used to read the light pen registers
'	----------------------------------------------------------------
'------
	calls EGAC16( 35 , pt(0) )
	ix=pt(0) : iy=pt(1)
	end sub
'
'	****************************************************************
'
	SUB SETCUR( ifunc , ix , iy ) STATIC
'	This routine is used to show or hide the cursor at the specified
'	position on the display.
'	----------------------------------------------------------------
'------
	if( ifunc = 0 ) then _
	  pt(0)=0 : _
	  pt(1)=ix : _
	  pt(2)=iy : _
	else _
	  pt(0)=1 _

	calls EGAC16( 36 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB DEFCUR( ifc , ibc , imask(1) , ihotx , ihoty ) STATIC
'	This routine is used to define the color and shape of the
'	graphics cursor.  The shape is determined by two contiguous sets
'	of bits masks background defined first.
'	----------------------------------------------------------------
'------ set colors
	pt(0)=2 : pt(1)=ifc : pt(2)=ibc
	calls EGAC16( 36 , pt(0) )
'------ copy mask over
	pt(0)=3
	for j=1 to 32
		pt(j)=imask(j-1)
	next j
'------ set hot spot
	pt(33)=ihotx : pt(34)=ihoty

	calls EGAC16( 36 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB OCLIP( ix1 , iy1 , ix2 , iy2 ) STATIC
'	This routine is used to set the shaded object clipping
'	boundaries.
'	----------------------------------------------------------------
'------
	pt(0)=ix1 : pt(1)=iy1 : pt(2)=ix2 : pt(3)=iy2
	calls EGAC16( 37 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB GENSPH( irad , buff(1) ) STATIC
'	This routine is used to generate a shaded sphere.
'	buff = must be static array
'	----------------------------------------------------------------
'------
	pt(0)=VARPTR( buff(0) )
	pt(1)=VARSEG( buff(0) )	
	pt(2)=irad
	calls EGAC16( 38 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB DRWSPH( ix , iy , irad , cols(1) , buff(1) ) STATIC
'	This routine is used to draw a shaded sphere.
'	----------------------------------------------------------------
'------
	pt(0)=VARPTR( buff(0) )
	pt(1)=VARSEG( buff(0) )	
	pt(2)=irad : pt(3)=ix : pt(4)=iy
	pt(5)=cols(0) : pt(6)=cols(1) : pt(7)=cols(2)
	calls EGAC16( 39 , pt(0) )
	end sub
'
'	****************************************************************
'
	SUB RDPIXL( ix, iy, icol ) STATIC
'	This routine is used to read a single pixel from the screen.
'	----------------------------------------------------------------
'------
	pt(0)=ix
	pt(1)=iy
	calls EGAC16( 40, pt(0) )
	icol=pt(2)
	end sub
'
'	****************************************************************
'
	SUB WRPIXL( ix, iy, icol ) STATIC
'	This routine is used to write a single pixel to the screen.
'	----------------------------------------------------------------
'------
	pt(0)=ix
	pt(1)=iy
	pt(2)=icol
	calls EGAC16( 41, pt(0) )
	end sub
'
'	****************************************************************
'
	SUB INQPOS( ix, iy ) STATIC
'	This routine is used to inquire the current position.
'	----------------------------------------------------------------
'------
	calls EGAC16( 42, pt(0) )
	ix=pt(0)
	iy=pt(1)
	end sub




